#ifndef _BSTRING_H
#define _BSTRING_H

#include <string>
#include <fstream>

using namespace std;

class BString
{// I: (0 <= bsLen < bsReserved) && (bsReserved % bsIncr == 0)
friend ostream& operator<<( ostream& tout, const BString& rhs );
friend bool operator==( const BString& lhs, const BString& rhs );
public:
   BString();
   BString( const char* rhs );
//   BString( const char* rhs="" );
   BString( const BString& rhs );
   ~BString() {  delete[] bsData;  };
   BString& operator=( const BString& rhs );
//   BString& operator=( BString rhs );
//   BString& operator=( const char* rhs );
   BString& assign( const BString& rhs ) { return (*this = rhs); }
   const char* c_str() const;
   size_t length() const {  return bsLen;  }
   bool empty() const {  return ( bsLen == 0 );  }
   char& at( int k ) const;
   char& operator[]( int pos ) const {  return bsData[pos];  }
   BString& operator+=( const BString& rhs );
   BString& append( const BString& rhs ) { return (*this += rhs); }
   void swap( BString& rhs );
   int compare( const BString& rhs ) const;
private:
   static const unsigned int bsIncr = 16;
   char*  bsData; 
   size_t bsLen; 
   size_t bsReserved;

   static size_t cStrLen( const char* cs );
   static int stringCmpr( const char* lhs, const char* rhs, int n );
}; // BString

struct BStringXptn
{
   enum { allocFailed, outOfRange };
   char funcName[100];
   int  errorCode;
   int  errorValue; 
   BStringXptn( char* mn, int ec, int ev = 0 )
   {  strncpy( funcName, mn, 99 );  funcName[99] = '\0';
      errorCode = ec;  errorValue = ev;  }
}; // BStringXptn

#endif // _BSTRING_H
